<?php
/**
 * Plugin Name: MailBigFile
 * Plugin URI: http://www.mailbigfile.com/app/wordpress
 * Description: Easily insert a receive files box on your site, allowing users to send files to your business account.
 * Text Domain: mail-big-file
 * Version: 0.2
 * Author: MailBigFile
 * Author URI: http://www.mailbigfile.com
 * License: CC-nd
 *
 * Version 0.2: Removed external links to files, renamed functions to be plugin specific, and moved loaded scripts to head.
 */

if (!defined('ABSPATH')) exit;

// Display the form
function mbf_display_form() {

    $mbf_output = "<div class='upload_form'>";

    $mbf_output .= "<div class='recipients'><label for='mbf_recipient' class='field_label'>Recipient:</label><div class='input'><select name='mbf_recipient' id='mbf_recipient'>";

    $email_addresses = preg_split('/\r\n|[\r\n]/', get_option('mailbigfile_email_addresses'));

    $mbf_output .= "<option value='' disabled selected>Please select..</option>";

    foreach($email_addresses as $email_address) {
        $mbf_output .= "<option>$email_address</option>";
    }

    $mbf_output .= "</select></div></div>";

    $mbf_output .= "<div class='email'><label for='mailbigfile_sender' class='field_label'>Your Email:</label><div class='input'><input type='email' id='mailbigfile_sender' name='mailbigfile_sender' required /></div></div>";

    $mbf_output .= "<div class='message'><label for='mailbigfile_message'>Message (optional):</label> <textarea id='mailbigfile_message' name='mailbigfile_message'></textarea></div>";

    $mbf_output .= "
    <div id='uploader' class='uploader' style='display: none;'>
        <a id='selectFiles' href='##'>
            <div class='select_files'>
                <img class='uploaderimg' src='". plugins_url('uploader.png', __FILE__) ."' />
                <span class='standby'>Drag or select files here...</span>
            </div>
            <div class='uploads'></div>
        </a>
        <input class='clear_form' type='button' value='Clear Files' />
    </div>";

    $mbf_output .= "</div>";

    global $mbf_load_scripts_true;
    $mbf_load_scripts_true = true;
    return $mbf_output;
}

// Register shortcode
if (get_option('mailbigfile_plugin_key') && get_option('mailbigfile_email_addresses')) {
    add_shortcode('mbf_receive', 'mbf_display_form');
}

// Only loading the scripts if they are needed
function mbf_register_scripts() {
    wp_enqueue_style('plupload', plugins_url('/plupload.ui.css',  __FILE__));
    wp_enqueue_script('plupload');
    //wp_register_script('mbf-plupload-script', '/wp-includes/js/plupload/plupload.full.min.js', array('jquery', 'jquery-ui-core'));
}

// plugins_url('/plupload.full.min.js', __FILE__)

add_action('init', 'mbf_register_scripts');
function mbf_load_scripts() {
    global $mbf_load_scripts_true;
    if (!$mbf_load_scripts_true==true) {
        return;
    }
    //wp_enqueue_style('mbf-plupload-style');
    //wp_print_scripts('plupload');
    require_once(plugin_dir_path(__FILE__).'/upload.php');
}
add_action('wp_footer', 'mbf_load_scripts');

// The plugin options
add_action( 'admin_menu', 'mbf_add_admin_menu' );
function mbf_add_admin_menu() {
    add_menu_page( 'Configure MailBigFile Plugin', 'MailBigFile', 'delete_others_pages', 'mail-big-file.php', 'mailbigfile_options', plugins_url('icon.png', __FILE__));
}

function mailbigfile_options(){
    ?>
    <div class="wrap">
        <h1>MailBigFile Options</h1><br>
        <form method="post" action="options.php">
            <?php
            settings_fields("plugin_setup");
            do_settings_sections("mailbigfile-options");
            submit_button();
            ?>
        </form>

    </div>
    <?php
}

function mailbigfile_display_plugin_key_element() {
    ?>
    <input type="text" required name="mailbigfile_plugin_key" id="mailbigfile_plugin_key" style="width: 100%" value="<?php echo get_option('mailbigfile_plugin_key'); ?>" />

    <p>You can get your key <a href="https://www.mailbigfile.com/plugin/getkey.php" target="_blank">here</a> (you must be an admin of your MailBigFile account).</p>
    <p>Please ensure you enter the key exactly as shown with no spaces.</p>
    <?php
}

function mailbigfile_display_email_addresses_element() {
    ?>
    <p>Enter the email addresses the user can select below - one per line. Each email address must exist as a recipient on your account.</p>
    <textarea required name="mailbigfile_email_addresses" id="mailbigfile_email_addresses" style="width: 100%;     height: 120px;" required ><?php echo get_option('mailbigfile_email_addresses'); ?></textarea>
    <?php
}

function mailbigfile_display_mailbigfile_fields() {
    add_settings_section("plugin_setup", "Plugin Setup", null, "mailbigfile-options");

    add_settings_field("mailbigfile_plugin_key", "Plugin Key", "mailbigfile_display_plugin_key_element", "mailbigfile-options", "plugin_setup");

    add_settings_field("mailbigfile_email_addresses", "Email Addresses", "mailbigfile_display_email_addresses_element", "mailbigfile-options", "plugin_setup");

    register_setting("plugin_setup", "mailbigfile_plugin_key");
    register_setting("plugin_setup", "mailbigfile_email_addresses");
}

add_action("admin_init", "mailbigfile_display_mailbigfile_fields");

// Nag user to fill in the plugin
function mailbigfile_email_addresses_admin_error_notice() {
    $class = "update-nag";
    echo "<div class=\"$class\"><b>MailBigFile</b>: Please <a href='". get_admin_url() ."admin.php?page=mail-big-file.php'>enter some email addresses</a> in order to use this plugin.</div>";
}

function mailbigfile_plugin_key_admin_error_notice() {
    $class = "update-nag";
    echo "<div class=\"$class\"><b>MailBigFile</b>: You must <a href='". get_admin_url() ."admin.php?page=mail-big-file.php'>enter your plugin key</a> in order to use this plugin.</div>";
}

if (!get_option('mailbigfile_plugin_key')) {
    add_action('admin_notices', 'mailbigfile_plugin_key_admin_error_notice');
}

if (!get_option('mailbigfile_email_addresses')) {
    add_action('admin_notices', 'mailbigfile_email_addresses_admin_error_notice');
}

?>