<?php if (!defined('ABSPATH')) exit; ?>

<script>

    function formatSizeUnits(bytes){
        if      (bytes >= 1073741824) { bytes = (bytes / 1073741824).toFixed(2) + ' GB'; }
        else if (bytes >= 1048576)    { bytes = (bytes / 1048576).toFixed(2) + ' MB'; }
        else if (bytes >= 1024)       { bytes = (bytes / 1024).toFixed(2) + ' KB'; }
        else if (bytes > 1)           { bytes = bytes + ' bytes'; }
        else if (bytes == 1)          { bytes = bytes + ' byte'; }
        else                          { bytes = '0 byte'; }
        return bytes;
    }

    (function ($, plupload) {
        var dom = {
            uploader: $("#uploader"),
            currentFile: '',
            uploads: $("div.uploads")
        };
        function isValidEmailAddress(emailAddress) {
            var pattern = new RegExp(/^((([a-z]|\d|[!#\$%&'\*\+\-\/=\?\^_`{\|}~]|[\u00A0-\uD7FF\uF900-\uFDCF\uFDF0-\uFFEF])+(\.([a-z]|\d|[!#\$%&'\*\+\-\/=\?\^_`{\|}~]|[\u00A0-\uD7FF\uF900-\uFDCF\uFDF0-\uFFEF])+)*)|((\x22)((((\x20|\x09)*(\x0d\x0a))?(\x20|\x09)+)?(([\x01-\x08\x0b\x0c\x0e-\x1f\x7f]|\x21|[\x23-\x5b]|[\x5d-\x7e]|[\u00A0-\uD7FF\uF900-\uFDCF\uFDF0-\uFFEF])|(\\([\x01-\x09\x0b\x0c\x0d-\x7f]|[\u00A0-\uD7FF\uF900-\uFDCF\uFDF0-\uFFEF]))))*(((\x20|\x09)*(\x0d\x0a))?(\x20|\x09)+)?(\x22)))@((([a-z]|\d|[\u00A0-\uD7FF\uF900-\uFDCF\uFDF0-\uFFEF])|(([a-z]|\d|[\u00A0-\uD7FF\uF900-\uFDCF\uFDF0-\uFFEF])([a-z]|\d|-|\.|_|~|[\u00A0-\uD7FF\uF900-\uFDCF\uFDF0-\uFFEF])*([a-z]|\d|[\u00A0-\uD7FF\uF900-\uFDCF\uFDF0-\uFFEF])))\.)+(([a-z]|[\u00A0-\uD7FF\uF900-\uFDCF\uFDF0-\uFFEF])|(([a-z]|[\u00A0-\uD7FF\uF900-\uFDCF\uFDF0-\uFFEF])([a-z]|\d|-|\.|_|~|[\u00A0-\uD7FF\uF900-\uFDCF\uFDF0-\uFFEF])*([a-z]|[\u00A0-\uD7FF\uF900-\uFDCF\uFDF0-\uFFEF])))\.?$/i);
            return pattern.test(emailAddress);
        };
        $('#mailbigfile_sender').keyup(function (event) {
            var new_sender_email = $(this).val();
            var new_reciever_email = $("#mbf_recipient").val();
            if(isValidEmailAddress(new_sender_email)&&isValidEmailAddress(new_reciever_email)) {
                $('#uploader').css( "display", "block");
            } else {
                $('#uploader').css( "display", "none");
            }
        });
        $('#mbf_recipient').change(function (event) {
            var new_sender_email = $("#mailbigfile_sender").val();
            var new_reciever_email = $(this).val();
            if(isValidEmailAddress(new_sender_email)&&isValidEmailAddress(new_reciever_email)) {
                $('#uploader').css( "display", "block");
            } else {
                $('#uploader').css( "display", "none");
            }
        });

        function makeId(num) {
            var text = "";
            var possible = "ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789";

            for(var i=0; i < num; i++) {
                text += possible.charAt(Math.floor(Math.random() * possible.length));
            }

            return text;
        }

        var bucket = '';
        var accessKeyId = '';
        var policy = '';
        var signature = '';
        var uploader;

        $.ajax({
            url: 'https://www.mailbigfile.com/plugin/generate_s3_credentials.php', // MBF SERVER
            type: "POST",
            data: "pluginKey=" + '<?php echo get_option('mailbigfile_plugin_key'); ?>',
            crossDomain: true,
            success:function(data){
                //console.log("success");
                accessKeyId = data[0];
                bucket = data[1];
                policy = data[2];
                signature = data[3];

                uploader = new plupload.Uploader({
                    runtimes: 'html5,flash,silverlight',
                    url: 'https://' + bucket + '.s3.amazonaws.com/',
                    drop_element: "uploader",
                    container: "uploader",
                    browse_button: "selectFiles",
                    urlstream_upload: true,
                    multipart: true,
                    multipart_params: {
                        'key': '${filename}',
                        'Filename': '${filename}',
                        'acl': 'private',
                        'AWSAccessKeyId': accessKeyId,
                        'policy': policy,
                        'signature': signature
                    },
                    file_data_name: 'file'
                });

                uploader.bind("Init", handlePluploadInit);
                uploader.bind("Error", handlePluploadError);
                uploader.bind("FilesAdded", handlePluploadFilesAdded);
                uploader.bind("QueueChanged", handlePluploadQueueChanged);
                uploader.bind("BeforeUpload", handlePluploadBeforeUpload);
                uploader.bind("UploadProgress", handlePluploadUploadProgress);
                uploader.bind("ChunkUploaded", handlePluploadChunkUploaded);
                uploader.bind("FileUploaded", handlePluploadFileUploaded);
                uploader.bind("StateChanged", handlePluploadStateChanged);
                uploader.init();

            },
            error:function(xhr,status,error){
                console.log(xhr);
                console.log(error);
                console.log("fail");
            }
        });

        function handlePluploadBeforeUpload(uploader, file) {
            //console.log("File upload about to start.", file.name);
            file.isChunked = isFileSizeChunkableOnS3(file.size);
            file.s3Key = generateUniqueID();
            
            uploader.settings.multipart_params['Content-Disposition'] = 'attachment;filename="' + file.name + '"';

            if (file.isChunked) {
                file.chunkIndex = 0;
                file.chunkKey = (file.s3Key + "." + file.chunkIndex);
                uploader.settings.chunk_size = plupload.parseSize("50mb"); // INDIVIDUAL CHUNK SIZE (minimum S3 will allow is 5MB)
                delete(uploader.settings.multipart_params.chunks);
                delete(uploader.settings.multipart_params.chunk);
                uploader.settings.multipart_params.key = file.chunkKey;
                uploader.settings.multipart_params.Filename = file.chunkKey;
            } else {
                uploader.settings.chunk_size = 0;
                uploader.settings.multipart_params.chunks = 0;
                uploader.settings.multipart_params.chunk = 0;
                uploader.settings.multipart_params.key = file.s3Key;
                uploader.settings.multipart_params.Filename = file.s3Key;
            }
        }
        function handlePluploadChunkUploaded(uploader, file, info) {
            //console.log("Chunk uploaded.", info.offset, "of", info.total, "bytes.");
            file.chunkKey = (file.s3Key + "." + ++file.chunkIndex);
            uploader.settings.multipart_params.key = file.chunkKey;
            uploader.settings.multipart_params.Filename = file.chunkKey;
        }
        function handlePluploadStateChanged(uploader) {
            if (isUploading()) {
                dom.uploader.addClass("uploading");
            }
        }
        function handlePluploadInit(uploader, params) {
            //console.log("Initialization complete.");
            //console.info("Drag-drop supported:", !!uploader.features.dragdrop);
        }
        function handlePluploadFilesAdded(uploader, files) {
            //console.log("Files selected.");

            // Cannot add more than 20 files at time. Also double check that the email addresses are valid.
            var error = '';

            if (uploader.files.length > 20) {
                error = "You cannot add more than 20 files at a time. If you want to send more, consider zipping the files first.";
            }
            else if (!isValidEmailAddress($('#mailbigfile_sender').val())) {
                error = "Your email does not appear to be valid.";
            }
            else if (!isValidEmailAddress($("#mbf_recipient").val())) {
                error = "The recipient's email address does not appear to be valid.";
            }

            if (error != '') {

                uploader.files.length -= files.length;
                files.length = 0;

                alert(error);

                return false;

            }

            // For use with *MX naming convention (format date to this convention).
            /*var d = new Date();
             var dayString = d.getDate() < 10 ? '0' + d.getDate().toString() : d.getDate().toString();
             var monthString = d.getMonth() < 10 ? '0' + d.getMonth().toString() : d.getMonth().toString();
             var date = d.getFullYear().toString() + monthString + dayString;*/

            var uploaderImg = "<?php echo plugins_url('uploader.png', __FILE__) ?>";

            // Add a div element for each added file.
            for (var i = 0; i < files.length; i++) {

                dom.uploads.append("<div class='uploader-progress " + files[i].id + "'><img src='" + uploaderImg + "' /><div class='name'>Pending - " + files[i].name + "</div><div class='size'>" + formatSizeUnits(files[i].size) + "</div><div class='percent'>0%</div></div>");

            }

            // If this is the first set of files added, hide the other contents in the upload form set the file to uploading.
            if (!isUploading() && files.length > 0) {
                $(".uploaderimg").hide();
                $(".standby").hide();
                dom.currentFile = $("#uploader ." + files[0].id);
                dom.currentFile.find(".name").html("Uploading - " + files[0].name);
            }

        }
        function handlePluploadUploadProgress(uploader, file) {
            //console.info("Upload progress:", file.percent);
            dom.currentFile.find(".percent").text(file.percent + "%");
        }
        function isUploading() {
            var currentState = uploader.state;
            return (currentState === plupload.STARTED);
        }
        function isFileSizeChunkableOnS3(fileSize) {
            var KB = 1024;
            var MB = (KB * 1024);
            var minSize = (MB * 55); // MINIMUM SIZE FOR CHUNKING
            return (fileSize > minSize);
        }
        function isNotUploading() {
            var currentState = uploader.state;
            return (currentState === plupload.STOPPED);
        }
        function handlePluploadQueueChanged(uploader) {
            //console.log("Files added to queue.");
            if (uploader.files.length && isNotUploading()) {
                uploader.start();
            }
        }
        function handlePluploadError(uploader, error) {
            console.warn("Error during upload.");
            console.log(error.code);
            console.log(error.message);
            console.log(error.file);
            console.log(error.response);
            console.log(error.status);
            console.log(error.responseHeaders);
        }
        function handlePluploadFileUploaded(uploader, file, response) {
            //console.log("Entire file uploaded.", response);
            if (file.isChunked) {
                //console.info("Base Key: " + encodeURIComponent(file.s3Key));
                //console.info("Chunk Index: " + file.chunkIndex);
            } else {
                //console.info("Base Key: " + encodeURIComponent(file.s3Key));
                file.chunkIndex = 0;
                //console.info("Chunk Index: " + file.chunkIndex);
                //console.log("not chunked");
            }
            var data = {};
            data.baseKey = fixedEncodeURIComponent(file.s3Key);
            data.chunkIndex = file.chunkIndex;
            data.fileSize = file.size;
            if (file.isChunked) {
                data.isChunked = 1;
            } else {
                data.isChunked = 0;
            }
            data.message = $("#mailbigfile_message").val();
            data.pluginKey = "<?php echo get_option('mailbigfile_plugin_key'); ?>";
            data.name = file.name;
            if($("#mbf_recipient").val()&&$("#mailbigfile_sender").val()!=='') {
                data.emailAddress = fixedEncodeURIComponent($("#mbf_recipient").val());
                data.sender = fixedEncodeURIComponent($("#mailbigfile_sender").val());
                dom.currentFile.find(".name").html("Sending - " + file.name);
                $.ajax({
                    url: 'https://www.mailbigfile.com/plugin/s3_ON_SERVER.php', // MBF SERVER
                    type: "POST",
                    crossDomain: true,
                    data: JSON.stringify(data),
                    dataType: "json",
                    contentType: 'application/json',
                    success:function(data){
                        //console.log(data);
                        //console.log("success");
                        $("#uploader ."+ file.id).find(".name").text("File Sent - " + file.name);
                    },
                    error:function(xhr,status,error){
                        console.log(xhr);
                        console.log(error);
                        console.log("fail");
                        $("#uploader ."+ file.id).find(".name").text("File NOT Sent - " + file.name);
                    }
                });
            }
            // Set the dom percent value to the next file, so the uploader updates the correct file in the queue.
            var index = uploader.files.indexOf(file);

            if (uploader.files.length > index + 1) {
                dom.currentFile = $("#uploader ." + uploader.files[index + 1].id);
                dom.currentFile.find(".name").text("Uploading - " + uploader.files[index + 1].name);
                //console.log(dom.currentFile);
            }
        }

        $(".clear_form").click(function() {

            if (isUploading()) {
                alert("Cannot clear files during upload.");
            }
            else {
                dom.uploader.removeClass("uploading");
                dom.uploads.empty();
                $(".uploaderimg").show();
                $(".standby").show();
                uploader.files.length = 0;
            }
        });

    })(jQuery, plupload);

    function fixedEncodeURIComponent(str) {
      return encodeURIComponent(str).replace(/[!'()*]/g, function(c) {
        return '%' + c.charCodeAt(0).toString(16);
      });
    }

    function generateUniqueID() {
        var d = new Date();
        var id = 'WMX-' + d.getFullYear();
        var month = d.getMonth() + 1;

        id += month < 10 ? '0' + month : month;
        id += d.getDate() < 10 ? '0' + d.getDate() : d.getDate();
        id += '-' + makeId(6);
        id += '-' + d.getTime();

        return id;
    }

    function makeId(num) {
        var text = "";
        var possible = "ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789";

        for(var i=0; i < num; i++) {
            text += possible.charAt(Math.floor(Math.random() * possible.length));
        }

        return text;
    }
</script>